<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */
require_once MAPLE_DIR .'/core/Smarty4Maple.class.php';

/**
 * Viewμ¹ԽӼ¹ԤԤFilter
 *   base_view
 *     `-- view
 *   ȤƻҴطΩ뤿 Filter
 *   Filter_View饹ήѤbase_viewεǽ
 *
 * @package     Maple.filter
 * @author      MAJIMA Satoru <satoru@majima.net>
 * @access      public
 */
class Filter_BaseView extends Filter
{
    /** */
    var $base_view_name = "baseView";
    
    /**
     * 󥹥ȥ饯
     *
     * @access  public
     */
    function Filter_BaseView()
    {
        parent::Filter();
    }

    /**
     * [[ǽ]]
     *
     * @access  public
     */
    function execute()
    {
        $className = get_class($this);

        $log =& LogFactory::getLog();
        $log->trace("${className}¹Ԥޤ", "{$className}#execute");

        //
        // 򵭽
        //

        //
        // ǰöΥե륿ܤ
        //
        $container =& DIContainerFactory::getContainer();
        $filterChain =& $container->getComponent("FilterChain");
        $filterChain->execute();

        //
        // ˸򵭽
        //
        $response =& $container->getComponent("Response");
        $view = $response->getView();

        if ($view != "") {
            $base_template = $this->getAttribute($this->base_view_name);
            $template = $this->getAttribute($view);
            if ($template == "") {
                $log->error("ƥץ졼ȥեμ˼Ԥޤ", "Filter_View#execute");
                exit;
            }

            if (preg_match("/location:/", $template)) {
                $url = preg_replace("/location:/", "", $template);
                $url = trim($url);
                $response->setRedirect($url);
            } else if (preg_match("/action:/", $template)) {
                $action = preg_replace("/action:/", "", $template);
                $action = trim($action);
                $actionChain =& $container->getComponent("ActionChain");
                $actionChain->add($action);
            } else {
                $renderer =& Smarty4Maple::getInstance();

                $actionChain =& $container->getComponent("ActionChain");
                $action =& $actionChain->getCurAction();
                $renderer->setAction($action);

                $errorList =& $actionChain->getCurErrorList();
                $renderer->setErrorList($errorList);

                $token =& $container->getComponent("Token");
                if (is_object($token)) {
                    $renderer->setToken($token);
                }

                $session =& $container->getComponent("Session");
                if (is_object($session)) {
                    $renderer->setSession($session);
                }

                $renderer->setScriptName($_SERVER['SCRIPT_NAME']);
                
                /*
                 * Modified by MJ
                 * base_viewƤȤϡview base_view񤵤ƤΤȤƽ
                 */
                $tmpPaths = explode("/", $_SERVER["SCRIPT_NAME"]);
                $paths = array_pop($tmpPaths);
                $path = implode("/", $tmpPaths);
                $scriptPath = (empty($path)) ? "" : $path."/";
                $renderer->assign("scriptPath", $scriptPath);
                
                if (!empty($base_template)) {
                    $renderer->assign("viewFile", $template);
                    $result = $renderer->fetch($base_template);
                } else {
                    $result = $renderer->fetch($template);
                }

                if ($result != "") {
                    $response->setResult($result);
                }
            }
        }

        $contentDisposition = $response->getContentDisposition();
        $contentType        = $response->getContentType();
        $result             = $response->getResult();
        $redirect           = $response->getRedirect();

        if ($redirect) {
            header("Location: ${redirect}");
        } else {
            if ($contentDisposition != "") {
                header("Content-disposition: ${contentDisposition}");
            }
            if ($contentType != "") {
                header("Content-type: ${contentType}");
            }

            print $result;
        }

        $log->trace("${className}θ¹Ԥޤ", "${className}#execute");
    }
}
?>
